G_BEGIN_DECLS

typedef void (*emp_cli_authentication_tls_certificate_signal_callback_accepted) (TpProxy *proxy,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_authentication_tls_certificate_connect_to_accepted (TpProxy *proxy,
    emp_cli_authentication_tls_certificate_signal_callback_accepted callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_authentication_tls_certificate_signal_callback_rejected) (TpProxy *proxy,
    const GPtrArray *arg_Rejections,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_authentication_tls_certificate_connect_to_rejected (TpProxy *proxy,
    emp_cli_authentication_tls_certificate_signal_callback_rejected callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_authentication_tls_certificate_callback_for_accept) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_authentication_tls_certificate_call_accept (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_authentication_tls_certificate_callback_for_accept callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_authentication_tls_certificate_callback_for_reject) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_authentication_tls_certificate_call_reject (TpProxy *proxy,
    gint timeout_ms,
    const GPtrArray *in_Rejections,
    emp_cli_authentication_tls_certificate_callback_for_reject callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_channel_interface_credentials_storage_callback_for_store_credentials) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_interface_credentials_storage_call_store_credentials (TpProxy *proxy,
    gint timeout_ms,
    gboolean in_Store,
    emp_cli_channel_interface_credentials_storage_callback_for_store_credentials callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_connection_interface_renaming_signal_callback_renamed) (TpProxy *proxy,
    guint arg_Original,
    guint arg_New,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_connection_interface_renaming_connect_to_renamed (TpProxy *proxy,
    emp_cli_connection_interface_renaming_signal_callback_renamed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_connection_interface_renaming_callback_for_request_rename) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_connection_interface_renaming_call_request_rename (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Identifier,
    emp_cli_connection_interface_renaming_callback_for_request_rename callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_debug_signal_callback_new_debug_message) (TpProxy *proxy,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_debug_connect_to_new_debug_message (TpProxy *proxy,
    emp_cli_debug_signal_callback_new_debug_message callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_debug_callback_for_get_messages) (TpProxy *proxy,
    const GPtrArray *out_Messages,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_debug_call_get_messages (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_debug_callback_for_get_messages callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_signal_callback_favourite_contacts_changed) (TpProxy *proxy,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_logger_connect_to_favourite_contacts_changed (TpProxy *proxy,
    emp_cli_logger_signal_callback_favourite_contacts_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_logger_callback_for_get_favourite_contacts) (TpProxy *proxy,
    const GPtrArray *out_Favourite_Contacts,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_get_favourite_contacts (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_logger_callback_for_get_favourite_contacts callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_callback_for_add_favourite_contact) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_add_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    emp_cli_logger_callback_for_add_favourite_contact callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_callback_for_remove_favourite_contact) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_remove_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    emp_cli_logger_callback_for_remove_favourite_contact callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_callback_for_clear) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_clear (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_logger_callback_for_clear callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_callback_for_clear_account) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_clear_account (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    emp_cli_logger_callback_for_clear_account callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


typedef void (*emp_cli_logger_callback_for_clear_entity) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_clear_entity (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gint in_Type,
    emp_cli_logger_callback_for_clear_entity callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);


G_END_DECLS
