#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

typedef struct _EmpSvcAuthenticationTLSCertificate EmpSvcAuthenticationTLSCertificate;

typedef struct _EmpSvcAuthenticationTLSCertificateClass EmpSvcAuthenticationTLSCertificateClass;

GType emp_svc_authentication_tls_certificate_get_type (void);
#define EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE \
  (emp_svc_authentication_tls_certificate_get_type ())
#define EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE, EmpSvcAuthenticationTLSCertificate))
#define EMP_IS_SVC_AUTHENTICATION_TLS_CERTIFICATE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE))
#define EMP_SVC_AUTHENTICATION_TLS_CERTIFICATE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_AUTHENTICATION_TLS_CERTIFICATE, EmpSvcAuthenticationTLSCertificateClass))


typedef void (*emp_svc_authentication_tls_certificate_accept_impl) (EmpSvcAuthenticationTLSCertificate *self,
    DBusGMethodInvocation *context);
void emp_svc_authentication_tls_certificate_implement_accept (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_accept_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_authentication_tls_certificate_return_from_accept (DBusGMethodInvocation *context);
static inline void
emp_svc_authentication_tls_certificate_return_from_accept (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_authentication_tls_certificate_reject_impl) (EmpSvcAuthenticationTLSCertificate *self,
    const GPtrArray *in_Rejections,
    DBusGMethodInvocation *context);
void emp_svc_authentication_tls_certificate_implement_reject (EmpSvcAuthenticationTLSCertificateClass *klass, emp_svc_authentication_tls_certificate_reject_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_authentication_tls_certificate_return_from_reject (DBusGMethodInvocation *context);
static inline void
emp_svc_authentication_tls_certificate_return_from_reject (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_authentication_tls_certificate_emit_accepted (gpointer instance);
void emp_svc_authentication_tls_certificate_emit_rejected (gpointer instance,
    const GPtrArray *arg_Rejections);

typedef struct _EmpSvcChannelInterfaceCredentialsStorage EmpSvcChannelInterfaceCredentialsStorage;

typedef struct _EmpSvcChannelInterfaceCredentialsStorageClass EmpSvcChannelInterfaceCredentialsStorageClass;

GType emp_svc_channel_interface_credentials_storage_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE \
  (emp_svc_channel_interface_credentials_storage_get_type ())
#define EMP_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE, EmpSvcChannelInterfaceCredentialsStorage))
#define EMP_IS_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE))
#define EMP_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE, EmpSvcChannelInterfaceCredentialsStorageClass))


typedef void (*emp_svc_channel_interface_credentials_storage_store_credentials_impl) (EmpSvcChannelInterfaceCredentialsStorage *self,
    gboolean in_Store,
    DBusGMethodInvocation *context);
void emp_svc_channel_interface_credentials_storage_implement_store_credentials (EmpSvcChannelInterfaceCredentialsStorageClass *klass, emp_svc_channel_interface_credentials_storage_store_credentials_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_interface_credentials_storage_return_from_store_credentials (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_interface_credentials_storage_return_from_store_credentials (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


typedef struct _EmpSvcChannelTypeServerTLSConnection EmpSvcChannelTypeServerTLSConnection;

typedef struct _EmpSvcChannelTypeServerTLSConnectionClass EmpSvcChannelTypeServerTLSConnectionClass;

GType emp_svc_channel_type_server_tls_connection_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION \
  (emp_svc_channel_type_server_tls_connection_get_type ())
#define EMP_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION, EmpSvcChannelTypeServerTLSConnection))
#define EMP_IS_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION))
#define EMP_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_TYPE_SERVER_TLS_CONNECTION, EmpSvcChannelTypeServerTLSConnectionClass))



typedef struct _EmpSvcConnectionInterfaceRenaming EmpSvcConnectionInterfaceRenaming;

typedef struct _EmpSvcConnectionInterfaceRenamingClass EmpSvcConnectionInterfaceRenamingClass;

GType emp_svc_connection_interface_renaming_get_type (void);
#define EMP_TYPE_SVC_CONNECTION_INTERFACE_RENAMING \
  (emp_svc_connection_interface_renaming_get_type ())
#define EMP_SVC_CONNECTION_INTERFACE_RENAMING(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CONNECTION_INTERFACE_RENAMING, EmpSvcConnectionInterfaceRenaming))
#define EMP_IS_SVC_CONNECTION_INTERFACE_RENAMING(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CONNECTION_INTERFACE_RENAMING))
#define EMP_SVC_CONNECTION_INTERFACE_RENAMING_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CONNECTION_INTERFACE_RENAMING, EmpSvcConnectionInterfaceRenamingClass))


typedef void (*emp_svc_connection_interface_renaming_request_rename_impl) (EmpSvcConnectionInterfaceRenaming *self,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_connection_interface_renaming_implement_request_rename (EmpSvcConnectionInterfaceRenamingClass *klass, emp_svc_connection_interface_renaming_request_rename_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_connection_interface_renaming_return_from_request_rename (DBusGMethodInvocation *context);
static inline void
emp_svc_connection_interface_renaming_return_from_request_rename (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_connection_interface_renaming_emit_renamed (gpointer instance,
    guint arg_Original,
    guint arg_New);

typedef struct _EmpSvcDebug EmpSvcDebug;

typedef struct _EmpSvcDebugClass EmpSvcDebugClass;

GType emp_svc_debug_get_type (void);
#define EMP_TYPE_SVC_DEBUG \
  (emp_svc_debug_get_type ())
#define EMP_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebug))
#define EMP_IS_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_DEBUG))
#define EMP_SVC_DEBUG_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebugClass))


typedef void (*emp_svc_debug_get_messages_impl) (EmpSvcDebug *self,
    DBusGMethodInvocation *context);
void emp_svc_debug_implement_get_messages (EmpSvcDebugClass *klass, emp_svc_debug_get_messages_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages);
static inline void
emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages)
{
  dbus_g_method_return (context,
      out_Messages);
}

void emp_svc_debug_emit_new_debug_message (gpointer instance,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message);

typedef struct _EmpSvcLogger EmpSvcLogger;

typedef struct _EmpSvcLoggerClass EmpSvcLoggerClass;

GType emp_svc_logger_get_type (void);
#define EMP_TYPE_SVC_LOGGER \
  (emp_svc_logger_get_type ())
#define EMP_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLogger))
#define EMP_IS_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_LOGGER))
#define EMP_SVC_LOGGER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLoggerClass))


typedef void (*emp_svc_logger_get_favourite_contacts_impl) (EmpSvcLogger *self,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_get_favourite_contacts (EmpSvcLoggerClass *klass, emp_svc_logger_get_favourite_contacts_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts);
static inline void
emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts)
{
  dbus_g_method_return (context,
      out_Favourite_Contacts);
}

typedef void (*emp_svc_logger_add_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_add_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_add_favourite_contact_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_remove_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_remove_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_remove_favourite_contact_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_impl) (EmpSvcLogger *self,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear (EmpSvcLoggerClass *klass, emp_svc_logger_clear_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_account_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear_account (EmpSvcLoggerClass *klass, emp_svc_logger_clear_account_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear_account (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear_account (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_entity_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gint in_Type,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear_entity (EmpSvcLoggerClass *klass, emp_svc_logger_clear_entity_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear_entity (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear_entity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_logger_emit_favourite_contacts_changed (gpointer instance,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed);


G_END_DECLS
